<?php
namespace Ma;

use ArrayAccess;

/**
 * @package         Ma
 * @class           Container
 * @implements      \ArrayAccess
 * @author          Mahdi Abu Yasmine
 * @date            2019-10-17 16:18:00 CET
 * @copyright       meta-tech.academy
 */
class Container implements ArrayAccess
{
    /**
     * @public
     * @param       $offset
     * @return      bool
     */
    public function offsetExists($offset): bool
    {
        return isset($this->$offset);
    }

    /**
     * @public
     * @param       $offset
     * @return      mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * @public
     * @param       $offset
     * @param       mixed   $value
     */
    public function offsetSet($offset , $value): void
    {
        $this->$offset = $value;
    }

    /**
     * @public
     * @param       $offset
     */
    public function offsetUnset($offset): void
    {
        unset($this->$offset);
    }

}
