<?php 
namespace Ma\Sys;

/**
 * manage system calls
 * 
 * @package         Ma\Sys
 * @class           Shell
 * @author          Mahdi Abu Yasmine
 * @date            2014-11-04 12:14:37 CET
 * @copyright       meta-tech.academy
 * @license         GNU GPL v3
 */
class Shell
{
    protected static array $output;
    protected static int $status;

    private function __construct()
    {
    }

    /**
     * call a shell cmd
     * 
     * @method      call
     * @public
     * @static
     * @param       string      $cmd    the command
     * @return      bool
     **/
    public static function call(string $cmd): bool
    {
        static::$output = [];
        exec($cmd, static::$output, static::$status);
        return static::$status==0;
    }

    /**
     * get the last cmd output
     * 
     * @method      output
     * @public
     * @static
     * @param      ?int     $index  index of output
     * @return      mixed
     */
    public static function output(?int $index)
    {
        return $index !== null && count(static::$output) > $index ? static::$output[$index] : static::$output;
    }

    /**
     * get the last cmd status
     * @method      status
     * @public
     * @static
     * @return      int
     */
    public static function status(): int
    {
        return static::$status;
    }

}
