<?php
namespace Ma\Sys;

use ReflectionClass;
/**
 * @package         Ma\Sys
 * @static
 * @class           TermOption
 * @author          Mahdi Abu Yasmine
 * @date            2019-07-24 22:59:10 CET
 * @copyright       meta-tech.academy
 * @license         GNU GPL v3
 */
class TermOption
{
    public const UNDEFINED   = -1;
    public const NORMAL      = 0;
    public const BOLD        = 1;
    public const FAINT       = 2;
    public const ITALIC      = 3;
    public const UNDERLINE   = 4;
    public const BLINK       = 5;
    public const RAPID_BLINK = 6;
    public const REVERSE     = 7;
    public const CONCEAL     = 8;
    public const STRIKE      = 9;

    private static ?array $opt;

    /**
     * @public
     * @static
     * @param       int     $value
     * @return      string
     */
    public static function getLabel(int $value): string
    {
        if (is_null(static::$opt)) {
            static::$opt = array_flip((new ReflectionClass(static::class))->getConstants());
        }
        return static::$opt[$value] ?: 'UNDEFINED';
    }

}
