<?php
namespace Ma\Util;

use SplObjectStorage;
use SplObserver;
use SplSubject;

/**
 * @package         Ma\Util
 * @class           Observable
 * @implements      \SplSubject
 * @author          Mahdi Abu Yasmine
 * @date            2019-08-22 11:29:10 CET
 * @copyright       meta-tech.academy
 * @license         GNU GPL v3
 */
class Observable implements SplSubject 
{
    protected SplObjectStorage $storage;

    /**
     * @constructor
     * @public
     */
    public function __construct()
    {
        $this->storage = new SplObjectStorage();
    }

    /**
     * @public
     * @param       SplObserver     $observer
     */
    public function attach(SplObserver $observer) {
        $this->storage->attach($observer);
    }

    /**
     * @public
     * @param       SplObserver     $observer
     */
    public function detach(SplObserver $observer) {
        $this->storage->detach($observer);
    }

    /**
     * @public
     */
    public function notify() {
        foreach ($this->storage as $observer) {
            $observer->update($this);
        }
    }
}
